



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Flask系列（三）蓝图、基于DButils实现数据库连接池、上下文管理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Flask系列（三）蓝图、基于DButils实现数据库连接池、上下文管理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:52:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>知识点回顾</h2>
<p>1、子类继承父类的三种方式</p>
<div>
<pre class="prettyprint linenums">class Dog(Animal): #子类  派生类<br />
    def __init__(self,name,breed, life_value,aggr):<br />
        # Animal.__init__(self,name,breed, life_value,aggr)#让子类执行父类的方法 就是父类名.方法名（参数），连self都得传<br />
        super().__init__(name,life_value,aggr) #super关键字  ，都不用传self了，在新式类里的<br />
        # super(Dog,self).__init__(name,life_value,aggr)  #上面super是简写<br />
        self.breed = breed<br />
    def bite(self,person):   #狗的派生方法<br />
        person.life_value -= self.aggr<br />
    def eat(self):  #父类方法的重写<br />
        super().eat()<br />
        print('dog is eating')</pre>
</div>
<p>2、对象通过索引设置值得三种方式</p>
<p>方式一、重写__setitem__方法</p>
<div>
<pre class="prettyprint linenums">class Foo(object):<br />
    def __setitem__(self, key, value):<br />
        print(key,value)

obj = Foo()<br />
obj["xxx"] = 123   #给对象赋值就会去执行__setitem__方法</pre>
</div>
<p>方式二、继承dict</p>
<div>
<pre class="prettyprint linenums">class Foo(dict):<br />
    pass

obj = Foo()<br />
obj["xxx"] = 123<br />
print(obj)</pre>
</div>
<p>方式三：继承dict，重写__init__方法时，记得要继承父类的__init__方法</p>
<div>
<pre class="prettyprint linenums">class Foo(dict):<br />
    def __init__(self,val):<br />
        # dict.__init__(self, val)#继承父类方式一<br />
        # super().__init__(val)  #继承父类方式二<br />
        super(Foo,self).__init__(val)#继承父类方式三<br />
obj = Foo({"xxx":123})<br />
print(obj)</pre>
</div>
<p>总结：如果遇到obj[&lsquo;xxx&rsquo;] =&nbsp;xx,</p>
<p>- 重写了__setitem__方法</p>
<p>- 继承dict</p>
<p>3、测试__name__方法</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">app1中：<br />
    import app2<br />
    print('app1', __name__)

app2中：<br />
    print('app2', __name__)</pre>
</div>
<p>现在app1是主程序，运行结果截图</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412144920355-1171177484.png" /></p>
<p>总结：</p>
<p>如果是在自己的模块中运行，__name__就是__main__，如果是从别的文件中导入进来的，就不是__main__了</p>
<h2>一、设置配置文件的几种方式</h2>
<div>
<pre class="prettyprint linenums">==========方式一：============<br />
 app.config['SESSION_COOKIE_NAME'] = 'session_lvning'  #这种方式要把所有的配置都放在一个文件夹里面，看起来会比较乱，所以选择下面的方式<br />
==========方式二：==============<br />
app.config.from_pyfile('settings.py')  #找到配置文件路径，创建一个模块，打开文件，并获取所有的内容，再将配置文件中的所有值，都封装到上一步创建的配置文件模板中

print(app.config.get("CCC"))<br />
=========方式三：对象的方式============<br />
 import os<br />
 os.environ['FLAKS-SETTINGS'] = 'settings.py'<br />
 app.config.from_envvar('FLAKS-SETTINGS') 

===============方式四（推荐）：字符串的方式，方便操作，不用去改配置，直接改变字符串就行了 ==============<br />
app.config.from_object('settings.DevConfig')

----------settings.DevConfig----------<br />
from app import app<br />
class BaseConfig(object):<br />
    NNN = 123  #注意是大写<br />
    SESSION_COOKIE_NAME = "session_sss"

class TestConfig(BaseConfig):<br />
    DB = "127.0.0.1"

class DevConfig(BaseConfig):<br />
    DB = "52.5.7.5"

class ProConfig(BaseConfig):<br />
    DB = "55.4.22.4"</pre>
</div>
<p>要想在视图函数中获取配置文件的值，都是通过app.config来拿。但是如果视图函数和Flask创建的对象app不在一个模块。就得</p>
<p>导入来拿。可以不用导入，。直接导入一个current_app，这个就是当前的app对象，用current_app.config就能查看到了当前app的所有的配置文件</p>
<p>from flask import Flask,current_app</p>
<div>
<pre class="prettyprint linenums">@app.route('/index',methods=["GET","POST"])<br />
def index():<br />
    print(current_app.config)   #当前的app的所有配置<br />
    session["xx"] = "fdvbn"<br />
    return "index"</pre>
</div>
<h2>二、蓝图（flask中多py文件拆分都要用到蓝图）</h2>
<p>如果代码非常多，要进行归类。不同的功能放在不同的文件，吧相关的视图函数也放进去。蓝图也就是对flask的目录结构进行分配（应用于小，中型的程序），</p>
<p>1、小中型：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412150310177-1493091980.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412150325808-1351204672.png" /></p>
<p>manage.py</p>
<div>
<pre class="prettyprint linenums">import fcrm<br />
if __name__ == '__main__':<br />
    fcrm.app.run()</pre>
</div>
<p>__init__.py(只要导入fcrm就会执行__init__.py文件)</p>
<div>
<pre class="prettyprint linenums">from flask import Flask<br />
#导入accout 和order<br />
from fcrm.views import accout<br />
from fcrm.views import order<br />
app = Flask(__name__)<br />
print(app.root_path)  #根目录

app.register_blueprint(accout.accout)  #吧蓝图注册到app里面，accout.accout是创建的蓝图对象<br />
app.register_blueprint(order.order)</pre>
</div>
<p>accout.py</p>
<div>
<pre class="prettyprint linenums">from flask import  Blueprint,render_template<br />
accout = Blueprint("accout",__name__)

@accout.route('/accout')<br />
def xx():<br />
    return "accout"

@accout.route("/login")<br />
def login():<br />
    return render_template("login.html")</pre>
</div>
<p>order.py</p>
<div>
<pre class="prettyprint linenums">from flask import Blueprint<br />
order = Blueprint("order",__name__)

@order.route('/order')<br />
def register():   #注意视图函数的名字不能和蓝图对象的名字一样<br />
    return "order</pre>
</div>
<p>使用蓝图时需要注意的</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412150654892-48868523.png" /></p>
<p>2、大型：</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412150904258-1699310465.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412150918054-1640074167.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1020990/201804/1020990-20180412150928720-1149030379.png" /></p>
<h2>三、数据库连接池</h2>
<p>flask中是没有ORM的，如果在flask里面连接数据库有两种方式</p>
<p>1：pymysql<br />2：SQLAlchemy<br />是python 操作数据库的一个库。能够进行 orm 映射官方文档 sqlchemy<br />SQLAlchemy&ldquo;采用简单的Python语言，为高效和高性能的数据库访问设计，实现了完整的企业级持久模型&rdquo;。SQLAlchemy的理念是，SQL数据库的量级和性能重要于对象集合；而对象集合的抽象又重要于表和行。</p>
<p>1、连接池原理</p>
<div>
<pre class="prettyprint linenums">   - BDUtils数据库链接池<br />
                - 模式一：基于threaing.local实现为每一个线程创建一个连接，关闭是<br />
                  伪关闭，当前线程可以重复<br />
                - 模式二：连接池原理<br />
                        - 可以设置连接池中最大连接数    9<br />
                        - 默认启动时，连接池中创建连接  5

                        - 如果有三个线程来数据库中获取连接：<br />
                            - 如果三个同时来的，一人给一个链接<br />
                            - 如果一个一个来，有时间间隔，用一个链接就可以为三个线程提供服务<br />
                                - 说不准<br />
                                    有可能:1个链接就可以为三个线程提供服务<br />
                                    有可能:2个链接就可以为三个线程提供服务<br />
                                    有可能:3个链接就可以为三个线程提供服务<br />
                         PS、：maxshared在使用pymysql中均无用。链接数据库的模块：只有threadsafety&gt;1的时候才有用</pre>
</div>
<p>2、pymysql方式实现连接池</p>
<p>方式一、每次操作都要链接数据库，链接次数过多</p>
<div>
<pre class="prettyprint linenums">#!usr/bin/env python<br />
# -*- coding:utf-8 -*-<br />
import pymysql<br />
from  flask import Flask

app = Flask(__name__)

# 方式一：这种方式每次请求，反复创建数据库链接，多次链接数据库会非常耗时<br />
#        解决办法：放在全局，单例模式<br />
@app.route('/index')<br />
def index():<br />
    # 链接数据库<br />
    conn = pymysql.connect(host="127.0.0.1",port=3306,user='root',password='', database='pooldb',charset='utf8')<br />
    cursor = conn.cursor()<br />
    cursor.execute("select * from td where id=%s", [5, ])<br />
    result = cursor.fetchall()  # 获取数据<br />
    cursor.close()<br />
    conn.close()  # 关闭链接<br />
    print(result)<br />
    return  "执行成功"

if __name__ == '__main__':<br />
    app.run(debug=True)</pre>
</div>
<p>方式二、不支持并发</p>
<div>
<pre class="prettyprint linenums">#!usr/bin/env python<br />
# -*- coding:utf-8 -*-<br />
import pymysql<br />
from  flask import Flask<br />
from threading import RLock

app = Flask(__name__)<br />
CONN = pymysql.connect(host="127.0.0.1",port=3306,user='root',password='', database='pooldb',charset='utf8')<br />
# 方式二：放在全局，如果是单线程，这样就可以，但是如果是多线程，就得加把锁。这样就成串行的了<br />
#        不支持并发，也不好。所有我们选择用数据库连接池<br />
@app.route('/index')<br />
def index():<br />
    with RLock:<br />
        cursor = CONN.cursor()<br />
        cursor.execute("select * from td where id=%s", [5, ])<br />
        result = cursor.fetchall()  # 获取数据<br />
        cursor.close()<br />
        print(result)<br />
        return  "执行成功"<br />
if __name__ == '__main__':<br />
    app.run(debug=True)</pre>
</div>
<p>3、DButils模块使用</p>
<p>方式三、由于上面两种方案都不完美，所以得把方式一和方式二联合一下（既让减少链接次数，也能支持并发）所有了方式三，需要</p>
<p>导入一个DButils模块</p>
<p>基于DButils实现的数据库连接池有两种模式：</p>
<p>模式一：为每一个线程创建一个链接（是基于本地线程来实现的。thread.local），每个线程独立使用自己的数据库链接，该线程关闭不是真正的关闭，本线程再次调用时，还是使用的最开始创建的链接，直到线程终止，数据库链接才关闭</p>
<p>注：&nbsp;模式一：如果线程比较多还是会创建很多连接，模式二更常用</p>
<div>
<pre class="prettyprint linenums">#!usr/bin/env python<br />
# -*- coding:utf-8 -*-<br />
from flask import Flask<br />
app = Flask(__name__)<br />
from DBUtils.PersistentDB import PersistentDB<br />
import pymysql<br />
POOL = PersistentDB(<br />
    creator=pymysql,  # 使用链接数据库的模块<br />
    maxusage=None,  # 一个链接最多被重复使用的次数，None表示无限制<br />
    setsession=[],  # 开始会话前执行的命令列表。如：["set datestyle to ...", "set time zone ..."]<br />
    ping=0,<br />
    # ping MySQL服务端，检查是否服务可用。# 如：0 = None = never, 1 = default = whenever it is requested, 2 = when a cursor is created, 4 = when a query is executed, 7 = always<br />
    closeable=False,<br />
    # 如果为False时， conn.close() 实际上被忽略，供下次使用，再线程关闭时，才会自动关闭链接。如果为True时， conn.close()则关闭链接，那么再次调用pool.connection时就会报错，因为已经真的关闭了连接（pool.steady_connection()可以获取一个新的链接）<br />
    threadlocal=None,  # 本线程独享值得对象，用于保存链接对象，如果链接对象被重置<br />
    host='127.0.0.1',<br />
    port=3306,<br />
    user='root',<br />
    password='',<br />
    database='pooldb',<br />
    charset='utf8'<br />
)

@app.route('/func')<br />
def func():<br />
　　conn = POOL.connection()<br />
　　cursor = conn.cursor()<br />
　　cursor.execute('select * from tb1')<br />
　　result = cursor.fetchall()<br />
　　cursor.close()<br />
　　conn.close() # 不是真的关闭，而是假的关闭。 conn = pymysql.connect()   conn.close()

　　conn = POOL.connection()<br />
　　cursor = conn.cursor()<br />
　　cursor.execute('select * from tb1')<br />
　　result = cursor.fetchall()<br />
　　cursor.close()<br />
　　conn.close()<br />
if __name__ == '__main__': app.run(debug=True)</pre>
</div>
<p>模式二：创建一个链接池，为所有线程提供连接，使用时来进行获取，使用完毕后在放回到连接池。</p>
<p>　　　　PS：假设最大链接数有10个，其实也就是一个列表，当你pop一个，人家会在append一个，链接池的所有的链接都是按照排队的这样的方式来链接的。</p>
<p>　　　　　链接池里所有的链接都能重复使用，共享的，&nbsp;即实现了并发，又防止了链接次数太多</p>
<div>
<pre class="prettyprint linenums">import time<br />
import pymysql<br />
import threading<br />
from DBUtils.PooledDB import PooledDB, SharedDBConnection<br />
POOL = PooledDB(<br />
    creator=pymysql,  # 使用链接数据库的模块<br />
    maxconnections=6,  # 连接池允许的最大连接数，0和None表示不限制连接数<br />
    mincached=2,  # 初始化时，链接池中至少创建的空闲的链接，0表示不创建

    maxcached=5,  # 链接池中最多闲置的链接，0和None不限制<br />
    maxshared=3,  # 链接池中最多共享的链接数量，0和None表示全部共享。PS: 无用，因为pymysql和MySQLdb等模块的 threadsafety都为1，所有值无论设置为多少，_maxcached永远为0，所以永远是所有链接都共享。<br />
    blocking=True,  # 连接池中如果没有可用连接后，是否阻塞等待。True，等待；False，不等待然后报错<br />
    maxusage=None,  # 一个链接最多被重复使用的次数，None表示无限制<br />
    setsession=[],  # 开始会话前执行的命令列表。如：["set datestyle to ...", "set time zone ..."]<br />
    ping=0,<br />
    # ping MySQL服务端，检查是否服务可用。# 如：0 = None = never, 1 = default = whenever it is requested, 2 = when a cursor is created, 4 = when a query is executed, 7 = always<br />
    host='127.0.0.1',<br />
    port=3306,<br />
    user='root',<br />
    password='',<br />
    database='pooldb',<br />
    charset='utf8'<br />
)

def func():<br />
    # 检测当前正在运行连接数的是否小于最大链接数，如果不小于则：等待或报raise TooManyConnections异常<br />
    # 否则<br />
    # 则优先去初始化时创建的链接中获取链接 SteadyDBConnection。<br />
    # 然后将SteadyDBConnection对象封装到PooledDedicatedDBConnection中并返回。<br />
    # 如果最开始创建的链接没有链接，则去创建一个SteadyDBConnection对象，再封装到PooledDedicatedDBConnection中并返回。<br />
    # 一旦关闭链接后，连接就返回到连接池让后续线程继续使用。

    # PooledDedicatedDBConnection<br />
    conn = POOL.connection()

    # print(th, '链接被拿走了', conn1._con)<br />
    # print(th, '池子里目前有', pool._idle_cache, '\r\n')

    cursor = conn.cursor()<br />
    cursor.execute('select * from tb1')<br />
    result = cursor.fetchall()<br />
    conn.close()

    conn = POOL.connection()

    # print(th, '链接被拿走了', conn1._con)<br />
    # print(th, '池子里目前有', pool._idle_cache, '\r\n')

    cursor = conn.cursor()<br />
    cursor.execute('select * from tb1')<br />
    result = cursor.fetchall()<br />
    conn.close()

func()</pre>
</div>
<div>
<div>
<pre class="prettyprint linenums">import pymysql<br />
import threading<br />
from DBUtils.PooledDB import PooledDB, SharedDBConnection<br />
POOL = PooledDB(<br />
    creator=pymysql,  # 使用链接数据库的模块<br />
    maxconnections=20,  # 连接池允许的最大连接数，0和None表示不限制连接数<br />
    mincached=2,  # 初始化时，链接池中至少创建的空闲的链接，0表示不创建<br />
    maxcached=5,  # 链接池中最多闲置的链接，0和None不限制<br />
    #maxshared=3,  # 链接池中最多共享的链接数量，0和None表示全部共享。PS: 无用，因为pymysql和MySQLdb等模块的 threadsafety都为1，所有值无论设置为多少，_maxcached永远为0，所以永远是所有链接都共享。<br />
    blocking=True,  # 连接池中如果没有可用连接后，是否阻塞等待。True，等待；False，不等待然后报错<br />
    maxusage=None,  # 一个链接最多被重复使用的次数，None表示无限制<br />
    setsession=[],  # 开始会话前执行的命令列表。如：["set datestyle to ...", "set time zone ..."]<br />
    ping=0,<br />
    # ping MySQL服务端，检查是否服务可用。# 如：0 = None = never, 1 = default = whenever it is requested, 2 = when a cursor is created, 4 = when a query is executed, 7 = always<br />
    host='192.168.11.38',<br />
    port=3306,<br />
    user='root',<br />
    passwd='apNXgF6RDitFtDQx',<br />
    db='m2day03db',<br />
    charset='utf8'<br />
)

def connect():<br />
    # 创建连接<br />
    # conn = pymysql.connect(host='192.168.11.38', port=3306, user='root', passwd='apNXgF6RDitFtDQx', db='m2day03db')<br />
    conn = POOL.connection()<br />
    # 创建游标<br />
    cursor = conn.cursor(pymysql.cursors.DictCursor)

    return conn,cursor

def close(conn,cursor):<br />
    # 关闭游标<br />
    cursor.close()<br />
    # 关闭连接<br />
    conn.close()

def fetch_one(sql,args):<br />
    conn,cursor = connect()<br />
    # 执行SQL，并返回收影响行数<br />
    effect_row = cursor.execute(sql,args)<br />
    result = cursor.fetchone()<br />
    close(conn,cursor)

    return result

def fetch_all(sql,args):<br />
    conn, cursor = connect()

    # 执行SQL，并返回收影响行数<br />
    cursor.execute(sql,args)<br />
    result = cursor.fetchall()

    close(conn, cursor)<br />
    return result

def insert(sql,args):<br />
    """<br />
    创建数据<br />
    :param sql: 含有占位符的SQL<br />
    :return:<br />
    """<br />
    conn, cursor = connect()

    # 执行SQL，并返回收影响行数<br />
    effect_row = cursor.execute(sql,args)<br />
    conn.commit()

    close(conn, cursor)

def delete(sql,args):<br />
    """<br />
    创建数据<br />
    :param sql: 含有占位符的SQL<br />
    :return:<br />
    """<br />
    conn, cursor = connect()

    # 执行SQL，并返回收影响行数<br />
    effect_row = cursor.execute(sql,args)

    conn.commit()

    close(conn, cursor)

    return effect_row

def update(sql,args):<br />
    conn, cursor = connect()

    # 执行SQL，并返回收影响行数<br />
    effect_row = cursor.execute(sql, args)

    conn.commit()

    close(conn, cursor)

    return effect_row</pre>
</div>
<p>sql_help</p></div>
<h2>四、本地线程</h2>
<p>保证每个线程都只有自己的一份数据，在操作时不会影响别人的，即使是多线程，自己的值也是互相隔离的</p>
<p>没用线程之前：</p>
<div>
<pre class="prettyprint linenums">import threading<br />
import time<br />
class Foo(object):<br />
    def __init__(self):<br />
        self.name = None<br />
local_values = Foo()

def func(num):<br />
    time.sleep(2)<br />
    local_values.name = num<br />
    print(local_values.name,threading.current_thread().name)

for i in range(5):<br />
    th = threading.Thread(target=func, args=(i,), name='线程%s' % i)<br />
    th.start()</pre>
</div>
<p>打印结果：</p>
<div>
<pre class="prettyprint linenums">1 线程1<br />
0 线程0<br />
2 线程2<br />
3 线程3<br />
4 线程4</pre>
</div>
<p>用了本地线程之后</p>
<div>
<pre class="prettyprint linenums">import threading<br />
import time<br />
# 本地线程对象<br />
local_values = threading.local()<br />
def func(num):

    """<br />
    # 第一个线程进来，本地线程对象会为他创建一个<br />
    # 第二个线程进来，本地线程对象会为他创建一个<br />
    {<br />
        线程1的唯一标识：{name:1},<br />
        线程2的唯一标识：{name:2},<br />
    }<br />
    :param num:<br />
    :return:<br />
    """<br />
    local_values.name = num #<br />
    # 线程停下来了<br />
    time.sleep(2)<br />
    # 第二个线程： local_values.name，去local_values中根据自己的唯一标识作为key，获取value中name对应的值<br />
    print(local_values.name, threading.current_thread().name)

for i in range(5):<br />
    th = threading.Thread(target=func, args=(i,), name='线程%s' % i)<br />
    th.start()</pre>
</div>
<p>打印结果：</p>
<div>
<pre class="prettyprint linenums">1 线程1<br />
2 线程2<br />
0 线程0<br />
4 线程4<br />
3 线程3</pre>
</div>
<h2>五、上下文管理</h2>
<p>1、原理猜想</p>
<div>
<pre class="prettyprint linenums">a、类似于本地线程<br />
            创建Local类：<br />
            {<br />
                线程或协程唯一标识: { 'stack':[request],'xxx':[session,] },<br />
                线程或协程唯一标识: { 'stack':[] },<br />
                线程或协程唯一标识: { 'stack':[] },<br />
                线程或协程唯一标识: { 'stack':[] },<br />
            }<br />
        b、上下文管理的本质<br />
            每一个线程都会创建一个上面那样的结构，<br />
            当请求进来之后，将请求相关数据添加到列表里面[request，]，以后如果使用时，就去读取<br />
            列表中的数据，请求完成之后，将request从列表中移除<br />
        c、关系<br />
            local = 小华={<br />
                线程或协程唯一标识: { 'stack':[] },<br />
                线程或协程唯一标识: { 'stack':[] },<br />
                线程或协程唯一标识: { 'stack':[] },<br />
                线程或协程唯一标识: { 'stack':[] },<br />
            }<br />
            stack = 强哥 = {<br />
                push<br />
                pop<br />
                top<br />
            }<br />
            存取东西时都要基于强哥来做<br />
        d、最近看过一些flask源码，flask还是django有些区别<br />
            - Flask和Django区别？<br />
                - 请求相关数据传递的方式<br />
                    - django：是通过传request参数实现的<br />
                    - Flask：基于local对象和，localstark对象来完成的<br />
                             当请求刚进来的时候就给放进来了，完了top取值就行了,取完之后pop走就行了

                    问题：多个请求过来会不会混淆<br />
                        -答： 不会，因为，不仅是线程的，还是协程，每一个协程都是有唯一标识的：<br />
                            from greenlent import getcurrentt as get_ident  #这个就是来获取唯一标识的 </pre>
</div>
<p>2、flask的request和session设置方式比较新颖，如果没有这种方式，那么就只能通过参数的传递。</p>
<p>flask是如何做的呢？</p>
<div>
<pre class="prettyprint linenums">        - 本地线程：是Flask自己创建的一个线程（猜想：内部是不是基于本地线程做的？）<br />
           vals = threading.local()<br />
           def task(arg):<br />
                vals.name = num<br />
            - 每个线程进来都是打印的自己的，只有自己的才能修改，<br />
            - 通过他就能保证每一个线程里面有一个数据库链接，通过他就能创建出数据库链接池的第一种模式<br />
        - 上下文原理<br />
            -  类似于本地线程<br />
        - 猜想：内部是不是基于本地线程做的？不是，是一个特殊的字典</pre>
</div>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*- coding:utf-8 -*-<br />
from functools import partial<br />
from flask.globals import LocalStack, LocalProxy

ls = LocalStack()

class RequestContext(object):<br />
    def __init__(self, environ):<br />
        self.request = environ

def _lookup_req_object(name):<br />
    top = ls.top<br />
    if top is None:<br />
        raise RuntimeError(ls)<br />
    return getattr(top, name)

session = LocalProxy(partial(_lookup_req_object, 'request'))

ls.push(RequestContext('c1')) # 当请求进来时，放入<br />
print(session) # 视图函数使用<br />
print(session) # 视图函数使用<br />
ls.pop() # 请求结束pop

ls.push(RequestContext('c2'))<br />
print(session)

ls.push(RequestContext('c3'))<br />
print(session)</pre>
</div>
<p>3、Flask内部实现</p>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*- coding:utf-8 -*-

from greenlet import getcurrent as get_ident

def release_local(local):<br />
    local.__release_local__()

class Local(object):<br />
    __slots__ = ('__storage__', '__ident_func__')

    def __init__(self):<br />
        # self.__storage__ = {}<br />
        # self.__ident_func__ = get_ident<br />
        object.__setattr__(self, '__storage__', {})<br />
        object.__setattr__(self, '__ident_func__', get_ident)

    def __release_local__(self):<br />
        self.__storage__.pop(self.__ident_func__(), None)

    def __getattr__(self, name):<br />
        try:<br />
            return self.__storage__[self.__ident_func__()][name]<br />
        except KeyError:<br />
            raise AttributeError(name)

    def __setattr__(self, name, value):<br />
        ident = self.__ident_func__()<br />
        storage = self.__storage__<br />
        try:<br />
            storage[ident][name] = value<br />
        except KeyError:<br />
            storage[ident] = {name: value}

    def __delattr__(self, name):<br />
        try:<br />
            del self.__storage__[self.__ident_func__()][name]<br />
        except KeyError:<br />
            raise AttributeError(name)

class LocalStack(object):<br />
    def __init__(self):<br />
        self._local = Local()

    def __release_local__(self):<br />
        self._local.__release_local__()

    def push(self, obj):<br />
        """Pushes a new item to the stack"""<br />
        rv = getattr(self._local, 'stack', None)<br />
        if rv is None:<br />
            self._local.stack = rv = []<br />
        rv.append(obj)<br />
        return rv

    def pop(self):<br />
        """Removes the topmost item from the stack, will return the<br />
        old value or `None` if the stack was already empty.<br />
        """<br />
        stack = getattr(self._local, 'stack', None)<br />
        if stack is None:<br />
            return None<br />
        elif len(stack) == 1:<br />
            release_local(self._local)<br />
            return stack[-1]<br />
        else:<br />
            return stack.pop()

    @property<br />
    def top(self):<br />
        """The topmost item on the stack.  If the stack is empty,<br />
        `None` is returned.<br />
        """<br />
        try:<br />
            return self._local.stack[-1]<br />
        except (AttributeError, IndexError):<br />
            return None

stc = LocalStack()

stc.push(123)<br />
v = stc.pop()

print(v)</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2x57w9.html">jquery 判断网络资源&comma;网络文件是否存在</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8odv5pq.html">svn 版本转为git</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kn3xj8.html">Oracle建表</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql5lee8.html">读文章《Flexbox详解》笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qygdndq.html">流量咪教你挖到5G免费流量</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2y1v38.html">一次Debug过程的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/r936zlg9.html">&lbrack;java&rsqb;java语言初探 servlet&plus;jsp架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2p5k8.html">PHP四种基础算法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/495kppm9.html">Java完成最简单的WebService创建及使用（REST方式，Jersey框架）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rrjj49.html">BRD</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egyjj9.html">java中数据类型转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zjzn49.html">关于ASP&period;NET中Button的OnClientClick属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dpm69.html">C&plus;&plus;和python使用struct传输二进制数据结构来实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okwzk19.html">asp&period;net EasyUI DataGrid 实现增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xzgwr9.html">Java基础知识强化43：StringBuffer类之StringBuffer和String的相互转化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w773xq.html">c&plus;&plus; bitset使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv152d1q.html">Sharepoint 2013 启用搜做服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgd6ee8.html">hibernate&period;cfg&period;xml文件的配置模板和不同数据库的配置參数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg166r8.html">PHP导出生成excel文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jvpjl8.html">configparser模块的常见用法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1d70x9.html">JS的事件冒泡和事件捕获</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlpe139.html">java jdk-awt&period;font在centos上中文乱码的问题&comma; 安装中文字体</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp66rk9.html">oracle之trunc&lpar;sysdate&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9632n2j9.html">Webservice简单案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em6lrk9.html">ajax的原理及实现方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnprodq.html">Burp Suite使用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlpg739.html">Effective C&plus;&plus; &mdash;&mdash; 构造&sol;析构&sol;赋值运算（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2jvke8.html">EditPlus详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/953lone8.html">JAXB简单样例</a>
			</li>
						<li><a href="https://www.batexi.com/a/953l4nv8.html">LeetCode&mdash;&mdash;Implement Stack using Queues</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
